local Proximo = Proximo

local COMBAT_EVENTS = Proximo.COMBAT_EVENTS

function Proximo:RegisterSpells()
  COMBAT_EVENTS["SPELL_CAST_START"] = "CASTSTART"
  COMBAT_EVENTS["SPELL_SUMMON"] = "CASTSTART"
  COMBAT_EVENTS["SPELL_CREATE"] = "CASTSTART"
  COMBAT_EVENTS["SPELL_CAST_SUCCESS"] = "CASTEND"
  COMBAT_EVENTS["SPELL_CAST_FAILED"] = "CASTEND"
  COMBAT_EVENTS["SPELL_INTERRUPT"] = "INTERRUPT"
end

function Proximo:UnregisterSpells()
  COMBAT_EVENTS["SPELL_CAST_START"] = nil
  COMBAT_EVENTS["SPELL_SUMMON"] = nil
  COMBAT_EVENTS["SPELL_CREATE"] = nil
  COMBAT_EVENTS["SPELL_CAST_SUCCESS"] = nil
  COMBAT_EVENTS["SPELL_CAST_FAILED"] = nil
  COMBAT_EVENTS["SPELL_INTERRUPT"] = nil
end

function Proximo:SpellStart(unit, spell, time)
  local frame = self.frame.buttons[unit].spellBar
  frame.time = 0
  frame.maxtime = time
  frame.spell = spell
  if self.db.profile.spelltime then
    frame.format = "%s (%.1f)"
  else
    frame.format = "%s"
  end
  frame.text:SetFormattedText(frame.format, spell, 0)
  frame:SetMinMaxValues(0, time)
  frame:SetValue(0)
  frame:Show()
end

function Proximo:HandleSpellEnd(unit)
  local frame = self.frame.buttons[unit].spellBar
  self:SpellEnd(frame)
end

function Proximo:SpellEnd(frame)
  frame.time = nil
  frame.maxtime = nil
  frame.spell = nil
  frame.format = nil
  frame.text:SetText(nil)
  frame:SetMinMaxValues(0, 0)
  frame:SetValue(0)
  frame:Hide()
end